Program hb2ascii (Input, Output, CharFile, FileVar);
Type
  String4  = String[4];
  String25 = String[25];

  CharArray    = Array [1..14,1..4] of Integer;
  DefenseArray = Array [1..12,1..2] of Integer;
  NotesArray   = Array [1..26] of String[78];
  CombatArray  = Array [1..6]  of String[16];
  NatDefArray  = Array [1..2]  of Integer;
  PowersRecord = Record
                   Desc     : String[45];
                   Cost     : Integer;
                   Roll     : String[3];
                 End;
  DisAdvRecord = Record
                   Desc     : String[29];
                   Cost     : Integer;
                 End;

  WeaponRecord = Record
                   WeName   : String[20];
                   WeMod    : String[4];
                   WeOcv    : String[2];
                   WeDam    : String[7];
                   WeStun   : String[4];
                   WeStrMin : String[2];
                   WeSize   : String[2];
                   WeSkill  : String[2];
                   WeNotes  : String[27];
                 End;

  CharacterRecord = Record
                      Name        : String25;
                      Desc        : String25;
                      TotalCost   : Integer;
                      Experience  : Integer;
                      Game        : String25;
                      Secret      : String25;
                      Player      : String25;
                      DisTotal    : Integer;
                      PowerTotal  : Integer;
                      CharTotal   : Integer;           {   STATS   }
                      BasePoints  : Integer;           { 1 = Value }
                      TotalPoints : Integer;           { 2 = Base  }
                      Stat        : CharArray;         { 3 = Maxe  }
                      Defense     : DefenseArray;      { 4 = Cost  }
                      Powers      : Array [1..48] of PowersRecord;
                      DisAdv      : Array [1..31] of DisadvRecord;
                      Weapon      : Array [1..16] of WeaponRecord;
                      RecPoints   : Integer;
                      RecRoll     : String4;
                      RepPoints   : Integer;
                      PD          : NatDefArray;
                      ED          : NatDefArray;
                      Notes       : NotesArray;
                      Combat      : CombatArray;
                    End;              { End of Character Record }

  CharacterFile = FILE of CharacterRecord;

Var
	FileVar : Text;
	CharFile : CharacterFile;
	CharRec  : CharacterRecord;

Procedure UnBlanks(J : Integer);
Var
  Index : Integer;
Begin
  For Index := 1 To J Do
    Write(FileVar,' ');
End;

Procedure Speed(Spd:Integer);
Const
  SpeedChart : Array [1..12,1..12] of Integer =((0,0,0,0,0,0,1,0,0,0,0,0),
                                                (0,0,0,0,0,1,0,0,0,0,0,1),
                                                (0,0,0,1,0,0,0,1,0,0,0,1),
                                                (0,0,1,0,0,1,0,0,1,0,0,1),
                                                (0,0,1,0,1,0,0,1,0,1,0,1),
                                                (0,1,0,1,0,1,0,1,0,1,0,1),
                                                (0,1,0,1,0,1,1,0,1,0,1,1),
                                                (0,1,1,0,1,1,0,1,1,0,1,1),
                                                (0,1,1,1,0,1,1,1,0,1,1,1),
                                                (0,1,1,1,1,1,0,1,1,1,1,1),
                                                (0,1,1,1,1,1,1,1,1,1,1,1),
                                                (1,1,1,1,1,1,1,1,1,1,1,1));
Var
  Index, I :Integer;

Begin
  I := 28;
  For Index := 1 to 12 Do
  	 If SpeedChart[Spd,Index] = 1 Then
  	 	Begin
    		Write(FileVar,' ',Index);
    		if index < 10 then
    			I := I - 2
    		Else
    			I := I - 3;
    	End;
  Write (FileVar, ' ':I);
End;

Procedure PrintPower(I : Integer; Var CharRec:CharacterRecord);
Var
  J : Integer;
Begin
  With CharRec.Powers[I] Do
    Begin
      If Cost = 0 Then
        Write(FileVar,' ':6)
      Else
        Write(FileVar,Cost:6);
      Write(FileVar,' ',Desc);
      UnBlanks(45-Length(Desc));
      Writeln(FileVar,Roll:4);
    End;
End;

Procedure PrintFront(CharRec : CharacterRecord);
Const
  DispStat : Array[1..14] Of String[18] = ('  Str........x1   ',
                      '  Dex........x3   ','  Con........x2   ',
                      '  Body.......x2   ','  Int........x1   ',
                      '  Ego........x2   ','  Pre........x1   ',
                      '  Com........x.5  ','  PD.........x1   ',
                      '  ED.........x1   ','  SPD........x10  ',
                      '  Rec........x2   ','  End........x.5  ',
                      '  Stun.......x1   ');
Var
  I,J      : Integer;
Begin                                  { of Print Front }
  With CharRec Do
    Begin
      Writeln(FileVar);
      Write(FileVar);
      Write(FileVar,'Name     : ',Name);
      Writeln(FileVar,'Game  : ':50-Length(Name),Game,' ':29-Length(Game));
      Write(FileVar,'Secret ID: ',Secret);
      Writeln(FileVar,'Player: ':50-Length(Secret),Player,' ':29-Length(Player));
      Write(FileVar,'Value Char','Cost Base Max  Pts':24);
      Writeln(FileVar,'   ','Pts.','Powers/Skills':23,'End':26);
      For I := 1 To 14 Do
        Begin
          Write(FileVar,Stat[I,1]:4,DispStat[I]);
          If I = 11 Then
            Begin
              Write(FileVar,Stat[I,2] / 10:3:1);
              If Stat[I,3] = 12 Then
                Write(FileVar,' N/A')
              Else
                Write(FileVar,Stat[I,3]:4);
            End
          Else
            Begin
              Write(FileVar,Stat[I,2]:3);
              If Stat[I,3] = 999 Then
                Write(FileVar,' N/A')
              Else
                Write(FileVar,Stat[I,3]:4);
            End;

          Write(FileVar,Stat[I,4]:4,' ');
          PrintPower(I,CharRec);
        End;
      Write(FileVar,'Characteristics Cost:':29,Chartotal:4,' ');
      PrintPower(15,CharRec);
      Write(FileVar,' ':34);
      PrintPower(16,CharRec);
      Write(FileVar,'Disadvantages',BasePoints:15,'+ ');
      Write(FileVar,'Pts.');
      PrintPower(17,CharRec);
      For I := 1 to 31 Do
        With DisAdv[I] Do
        Begin
          Write(FileVar,Desc);
          UnBlanks(29-Length(Desc));
          If Cost = 0 then
            Write(FileVar,' ':5)
          Else
            Write(FileVar,Cost:5);
          PrintPower(17+I,CharRec);
        End;

       Write(FileVar,'Exp:':7,'   Disadvantages Total:',Distotal:4);
       Writeln(FileVar,' ':2,PowerTotal:4,':Powers / Skills Cost');

       Write(FileVar,' ':3,Experience-(PowerTotal+CharTotal-DisTotal):4);
       Write(FileVar,'Experience Spent+':23,PowerTotal+Chartotal-Distotal:4);
       WriteLn(FileVar,'  ',CharTotal:4,'+Characteristics Cost');

       Write(FileVar,'Total Points=':30,TotalCost:4,'  ');
       Writeln(FileVar,TotalCost:4,'=Total Cost');

       Writeln(FileVar);

       Write(FileVar,'OCV',' (Dex/3):',Trunc(Stat[2,1] / 3 + 0.5):3,' ':3);
       Write(FileVar,'Phases:');
       Speed(Stat[11,1]);
       Writeln(FileVar,'  ','Combat Levels:  ','   ','Movement:       ');

       Write(FileVar,'INT Roll:':27,9+Trunc(Stat[5,1] / 5+ 0.5):3,'-',' ':24,Combat[1]);
       UnBlanks(16-Length(Combat[1]));
       Write(FileVar,' ':3,ComBat[5]);
       UnBlanks(16-Length(Combat[5]));
       Writeln(FileVar);

       Write(FileVar,'DCV',' (Dex/3):',TRUNC(Stat[2,1] / 3 + 0.5):3);
       Write(FileVar,'PER Roll:':12,9+Trunc(Stat[5,1] / 5 + 0.5):3,'-');
       Write(FileVar,'Rec Points:':17,RecPoints:4,'   ',ComBat[2]);
       UnBlanks(16-Length(ComBat[2]));
       Write(FileVar,'   ',ComBat[6]);
       UnBlanks(16-Length(ComBat[6]));
       Writeln(FileVar);

       Write(FileVar,'DEX Roll:':27,9+Trunc(Stat[2,1] / 5 + 0.5):3,'-');
       Write(FileVar,'Rec Roll  :':17,RecRoll:4,'   ',ComBat[3]);
       UnBlanks(16-Length(ComBat[3]));
       Writeln(FileVar,'PD (t/r):':12,PD[1]:3,'/',PD[2]:3);

       Write(FileVar,'ECV',':(Ego/3):',Trunc(Stat[6,1] / 3 + 0.5):3);
       Write(FileVar,'EGO Roll:':12,9+Trunc(Stat[6,1] / 5 + 0.5):3,'-');
       Write(FileVar,'Rep Points:':17,RepPoints:4,'   ',ComBat[4]);
       UnBlanks(16-Length(ComBat[4]));
       Writeln(FileVar,'ED (t/r):':12,ED[1]:3,'/',ED[2]:3);

       Write(FileVar,#12);
    End;
End;                                   { of Print Front }

Procedure PrintBack(CharRec : CharacterRecord);
Var
  I        : Integer;
Begin                                  { of Print Back }
  With CharRec Do
    Begin
      Writeln(FileVar);
      Writeln(FileVar,' ':40,'Weapons');
      Writeln(FileVar,'Weapon Name','Mod':14,' OCV  Damage Stun STR Size Skill  Notes',' ':25);
      For I := 1 To 16 Do
        With Weapon[I] Do
          Begin
            Write(FileVar,WeName);
            UnBlanks(20-Length(WeName));
            Write(FileVar,' ',WeMod:4,' ',WeOcv:3,' ');
            Write(FileVar,WeDam:7,' ',WeStun:4,' ',WeStrMin:3);
            Write(FileVar,' ',WeSize:4,'  ',WeSkill:3,'   ');
            Writeln(FileVar,WeNotes);
          End;

      Writeln(FileVar);

      Writeln(FileVar,' ':10,'Hit Location Chart');
      Writeln(FileVar,'Roll  Location Stun Body Norm OCV  PD  ED',' ':30,'DamageClass');
      Write(FileVar,'  3   Head #1   x5   x2   x2  -8  ',Defense[1,1]:3,'/',Defense[1,2]:3);
      Writeln(FileVar,'Damage  Killing  Normal':48);

      Write(FileVar,'  4   Head #2   x5   x2   x2  -8  ',Defense[2,1]:3,'/',Defense[2,2]:3);
      Write(FileVar,' ':4,'Placed Shot Chart');
      Writeln(FileVar,'1...    1 Pip    ...1d6 ':28);

      Write(FileVar,'  5   Head #3   x5   x2   x2  -8  ',Defense[3,1]:3,'/',Defense[3,2]:3,' ':5);
      Writeln(FileVar,'Area    OCV  Dice','2...  .5d6,1d6-1 ...2d6 ':27);

      Write(FileVar,'  6   Hands     x1   x.5  x.5 -6  ',Defense[4,1]:3,'/',Defense[4,2]:3,' ':3);
      Writeln(FileVar,'Head Shot -4  2d4+1','3...     1d6     ...3d6 ':27);

      Write(FileVar,' 7-8  Arms      x2   x.5  x.5 -5  ',Defense[5,1]:3,'/',Defense[5,2]:3,' ':3);
      Writeln(FileVar,'High Shot -2  2d6+1','4...    1d6+1    ...4d6 ':27);

      Write(FileVar,'  9   Shoulders x3   x1   x1  -5  ',Defense[6,1]:3,'/',Defense[6,2]:3,' ':3);
      Writeln(FileVar,'Body Shot -1  2d6+4','5... 1.5d6,2d6-1 ...5d6 ':27);

      Write(FileVar,'10-11 Chest     x3   x1   x1  -3  ',Defense[7,1]:3,'/',Defense[7,2]:3,' ':3);
      Writeln(FileVar,'Leg  Shot -2  2d6+7','6...     2d6     ...6d6 ':27);

      Write(FileVar,' 12   Stomach   x4   x1  x1.5 -7  ',Defense[8,1]:3,'/',Defense[8,2]:3,' ':3);
      Writeln(FileVar,'Low  Shot -4  d6+12','7...    2d6+1    ...7d6 ':27);

      Write(FileVar,' 13   Vitals    x4   x2  x1.5 -8  ',Defense[9,1]:3,'/',Defense[9,2]:3,' ':3);
      Writeln(FileVar,'8... 2.5d6,3d6-1 ...8d6 ':46);

      Write(FileVar,' 14   Thighs    x2   x1   x1  -4  ',Defense[10,1]:3,'/',Defense[10,2]:3,' ':3);
      Writeln(FileVar,'9...     3d6     ...9d6 ':46);

      Writeln(FileVar,'15-16 Legs      x1   x.5  x.5 -6  ',Defense[11,1]:3,'/',Defense[11,2]:3,' ':3);
      Writeln(FileVar,'17-18 Feet      x1   x.5  x.5 -8  ',Defense[12,1]:3,'/',Defense[12,2]:3,' ':3);
      Writeln(FileVar);


      Writeln(FileVar,' ':38,'Character Notes');
      For I := 1 TO 26 DO
          Writeln(FileVar,' ':6,Notes[I]);
      Write(FileVar,#12);
    End;
End;                                   { of Print Back }


Begin 											{ of Main Block }
   if paramcount <> 1 then Begin
   	Writeln ('HB2ASCII - HeroBase to ASCII Converter.');
   	Writeln ('Written by: Carl W. Oakes');
   	Writeln;
   	Writeln ('Usage: HB2ASCII FileName');
   End else Begin

		Assign (CharFile,paramstr(1)+'.HB');
		Reset (CharFile);
		Read (CharFile, CharRec);
		Close (CharFile);

		Assign (FileVar,paramstr(1)+'.TXT');
      Rewrite (FileVar);

   	PrintFront (CharRec);
   	PrintBack (CharRec);

   	Close (FileVar);
  End;
End.												{ of Main Block }